<?
 require_once($_path["include"]."cms.php");
 require_once($_path["include"]."data.php");

 class login extends BasePlugin
 {
  function main()
  {
   global $_config;

   if((request("e")=="login"||request("e")=="logout")&&request("s")) //login/logout attempt
   {
    $d=Data::cache($_config["usermodule"], "user");

    if(!$d->submit()&&$this->config["showErrors"])
    {
     $this->e->add($d->e);
     return false;
    }
   }

   return true;
  }

  function output()
  {
   global $_config;

   $output="";
   if($_config["usernr"]==$_config["anonnr"]) //not logged in
   {
    $d=Data::cache($_config["usermodule"], "user", "login");
    $d->setDefaultValue("e"); //make sure extra is set to login

    $config=$this->config;
    $config["handleSubmit"]=false;
    $config["reloadPage"]=false;
    $config["anchoring"]=false;

    $cms=new CMS($config);
    $cms->setData($d);
    $cms->referenceManipulation=false;

    if($this->config["httpsRedirect"]&&!isset($_SERVER["HTTPS"])) //redirect to HTTPS
    {
     //HTTPS requires secure coookie
     $params=session_get_cookie_params();

     if(!$params["secure"])
      session_set_cookie_params($params["lifetime"], $params["path"], $params["domain"], true);

     unset($params);

     $url="https://".$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
     $output.=$cms->form($url);
    }  
    else
     $output.=$cms->form();
   }
   else
   {
    if($this->config["showUsername"])
    {
     $d=Data::cache($_config["usermodule"], "view", "item");
     $d->setValue($d->getID(), $_config["usernr"]);

     $titleFields=$d->check("properties", "title");
     $d->setShowFields($titleFields);

     if(!$d->get()||!$d->next())
     {
      if($this->config["showErrors"])
      {
       $this->e->add($d->e);
       return false;
      }
     }
     else
     {
      if($this->config["showLoggedinText"])
       $output.="<div class=\"loggedin\">Logged in: ";

      $output.="<div class=\"user\">";

      foreach($titleFields as $field)
       $output.=$d->v[$field]." ";

      $output.="</div>\n";

      if($this->config["showLoggedinText"])
       $output.="</div>\n";
     }
    }

    if($this->config["showLogout"])
    {
     $d=Data::cache($_config["usermodule"], "user", "logout");
     $d->setDefaultValue("e"); //make sure extra is set to login

     $config=$this->config;
     $config["handleSubmit"]=false;
     $config["reloadPage"]=false;
     $config["anchoring"]=false;

     $cms=new CMS($config);
     $cms->setData($d);
     $cms->referenceManipulation=false;

     $output.=$cms->form();
    }
   }

   return $output;
  }

 }
?>
